﻿using System;
using System.IO;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using Microsoft.Win32;

namespace AutoDetectCsvSeparator
{
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void OpenFileDialog(object sender, RoutedEventArgs e)
        {
            var openFileDialog = new OpenFileDialog()
            {
                FileName = this.filePathTextBox.Text,
                DefaultExt = ".csv",
                Filter = "CSV Files|*.csv|TSV Files|*.tsv|Text Files|*.txt|All Files|*.*"
            };

            if (openFileDialog.ShowDialog() == true)
                this.filePathTextBox.Text = openFileDialog.FileName;
        }

        private char[] GetSeparators()
        {
            char result;
            return this.separatorsPanel.Children.OfType<CheckBox>().
                Where(checkBox => checkBox.IsChecked == true && char.TryParse(checkBox.Tag as string, out result)).
                Select(checkBox => char.Parse(checkBox.Tag as string)).
                Concat(this.otherSeparatorsTextBox.Text.Split(new char[] { ' ' }, StringSplitOptions.RemoveEmptyEntries).
                Where(separator => char.TryParse(separator, out result)).
                Select(separator => char.Parse(separator))).ToArray();
        }

        private void DetectSeparator(object sender, RoutedEventArgs e)
        {
            var separators = this.GetSeparators();

            using (var reader = new StreamReader(this.filePathTextBox.Text))
                this.resultTextBox.Text = CsvSeparatorDetector.Detect(reader, (int)this.rowsSlider.Value, GetSeparators().ToArray()).ToString();
        }
    }
}
